! Copyright (C) 2017 W. Robert Kellock.
!
! Talking to Isectd using Factor which is the slowest so far. On the other hand this is the most complete
! implementation out of the examples, because concatenative languages force you to think logically about
! everything you do :-)
!
! See http://factorcode.org/license.txt for BSD license.

USING: kernel io io.encodings.binary io.sockets prettyprint prettyprint.config io.encodings.ascii.private
alien.c-types alien.data specialized-arrays classes.struct accessors byte-arrays sequences multiline
windows.kernel32 math.parser math io.encodings.ascii io.encodings.string strings ;
IN: isectd

STRUCT: isdBadge 
{ hostpid char[7]  } 
{ priority char[3]  } 
{ id char[5]  } 
{ blockable char[3]  } 
{ service char[30]  }  
;

STRUCT: isdHeader 
{ len char[7] }
{ reply char[3] }
{ more char[3] }
{ sequence char[9] }
{ error char[3] }
{ command char[3] }
{ version char[3] }
{ workerid char[8] }
{ unused char[9] }
;

SPECIALIZED-ARRAYS: isdBadge isdHeader ;

! Factor out the repetition
: fill-array ( str -- array )
char >c-array
;
:  header-fill-field ( n struct -- struct array )
swap number>string fill-array
;

:  rtrim ( str -- str )
dup 0 swap index head
;

! Logging in detail
: isectd-header-out ( more reply len -- struct )
isdHeader <struct> header-fill-field 3 0 pad-tail >>more
header-fill-field 3 0 pad-tail >>reply
header-fill-field 7 0 pad-tail >>len
;
: isectd-badge ( -- struct )
isdBadge <struct> GetCurrentProcessId number>string fill-array 7 0 pad-tail >>hostpid
"2" fill-array 3 0 pad-tail >>priority
"op" fill-array 30 0 pad-tail >>service
;
: isectd-login ( -- )
48 0 0 isectd-header-out write flush isectd-badge write flush
;

! Reply being returned
: isectd-request ( null_terminated_string -- ) 
dup length 1 0 isectd-header-out write flush write flush 
;
: isectd-header-in ( -- len )
isdHeader <struct> 7 read rtrim ascii decode >string fill-array 7 0 pad-tail >>len
41 read drop len>> rtrim string>number
;

! The main that starts it all
: isectd-connect ( -- ) "localhost" 5501 <inet> binary [ isectd-login

"clients\0" 

ascii> isectd-request isectd-header-in 1 - read ascii decode
] with-client ... ;

MAIN: isectd-connect
