#
#   Isectd.py ( Talk to Isectd directly bypassing the C API )
#
#   Isectd expects all messages to contain a C struct (represented as a binary string) followed by an ascii string.
#
#	1.	To login send isdHeader + isdBadge (another C struct) which must contain a pid (pid is optional),
#		a priority and a service.
#	2.	Following a successful login send isdHeader + message which must be null terminated.
#	3.	You will receive back an isdHeader and a message.
#
from struct import *
from socket import *
import os

# login to Isectd
isdBadge = pack('7s3s5s3s30s',str(os.getpid()),'2','','','op')
isdHeader = pack('7s3s3s9s3s3s3s8s9s',str(len(isdBadge)),'','','','','','','','')# must always contain the message length

HOST = "localhost"    
PORT = 5501           
s = socket(AF_INET, SOCK_STREAM)
s.setsockopt(IPPROTO_TCP, TCP_NODELAY, 1)
s.setsockopt(SOL_SOCKET, SO_REUSEADDR, 1)
s.connect((HOST, PORT))

isdMsg = isdHeader + isdBadge
s.sendall(isdMsg)

# send data with string length and reply inside isdHeader
dataOut = "clients\0" # change this to whatever you like

isdHeader = pack("7s3s3s9s3s3s3s8s9s",str(len(dataOut)),'1','','','','','','','')# 1 means we want a reply back
s.sendall(isdHeader + dataOut)

# first we receive isdHeader back which in a real program we would have to unpack and utilise, particularly the length
# of the message about to follow and whether there will be more packets in this transaction.
data = s.recv(1024)
isdHeader = unpack('7s3s3s9s3s3s3s8s9s',data) # I presume any remaining information in the buffer is not flushed 
print "isdHeader = ",isdHeader

# immediately afterwards we receive the data string
data = s.recv(1024)
print "\nThe data string = ",data
s.close()


