"
Smalltalk is the most code heavy of the native implementations, but also surprisingly, the fastest!
Perhaps some clever optimisations have been incorporated into Squeak's SocketStream class. You might 
need to remove this comment for this file to be read into Squeak.
"

Object subclass: #IsdBadge
	instanceVariableNames: 'hostpid priority id blockable service'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Isectd'!

!IsdBadge methodsFor: 'printing' stamp: 'RK 10/3/2017 18:31'!
printRawVariables
	"concatenate and print all variables into array 48 bytes long"

	^ hostpid, priority, id, blockable, service .! !


!IsdBadge methodsFor: 'initialize' stamp: 'RK 10/3/2017 18:30'!
initialize
	"Both isdBadge & isdHeader must be exactly 48 bytes long"
	super initialize.
	hostpid := #[0 0 0 0 0 0 0]. "Only used for reporting purposes"
	"2"
	priority := #[50 0 0]. "Only used by client"
	id := #[0 0 0 0 0].
	blockable := #[0 0 0].
	"echo"
	service := #[111 112 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0].! !


Object subclass: #IsdHeader
	instanceVariableNames: 'len reply more sequence error command version workerid unused'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Isectd'!

!IsdHeader methodsFor: 'setting' stamp: 'RK 10/3/2017 16:42'!
getLen: aBinaryString
	"transform aBinaryString into a length of 999,999. Since len is the first substring in IsdHeader
	we can simply parse it and ignore everything after
	 "
^aBinaryString asString asInteger.! !

!IsdHeader methodsFor: 'setting' stamp: 'RK 10/3/2017 18:21'!
setLen: aInteger
	"transform aInteger into byte array of length 7 which works up to a 
	 length of 999,999 because the array must include a null at the end 
	"
  	| temp |
	len := String new: 7.
	temp := aInteger asString.
	1 to: temp size do: [:x | len at: x put: (temp at: x)].! !

!IsdHeader methodsFor: 'setting' stamp: 'RK 10/3/2017 12:33'!
setToReply
	"looking for a reply"

	reply := #[49 0 0].! !


!IsdHeader methodsFor: 'printing' stamp: 'RK 10/3/2017 18:31'!
printRawVariables
	"concatenate and print all variables into array 48 bytes long"
 
	^ len, reply, more, sequence, error, command, version, workerid, unused.! !


!IsdHeader methodsFor: 'initialize' stamp: 'RK 10/3/2017 18:30'!
initialize
	"Initial state set for client login with length of 48"
	super initialize.
	"48"
	len := #[52 56 0 0 0 0 0].
	reply := #[0 0 0].
	more := #[0 0 0].
	sequence := #[0 0 0 0 0 0 0 0 0].
	error := #[0 0 0].
	command := #[0 0 0].
	version := #[0 0 0].
	workerid := #[0 0 0 0 0 0 0 0].
	unused := #[0 0 0 0 0 0 0 0 0].! !


Object subclass: #IsectdRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Isectd'!

!IsectdRequest methodsFor: 'connection' stamp: 'RK 10/3/2017 18:38'!
open
	"send an echo message to Isectd"
	
   | stream header badge request msg reply len |
	stream := SocketStream openConnectionToHostNamed: 'localhost' port: 5501 . 
	header := IsdHeader new .
	badge := IsdBadge new .
	request := header printRawVariables, badge printRawVariables .
	stream binary nextPutAll: request asByteArray .
	stream flush .
	Transcript clear show: request; cr .
   	msg := 'clients', Character null .
	header setLen: msg size .
	header setToReply .
	request := header printRawVariables, msg asByteArray .
	stream binary nextPutAll: request asByteArray .
	stream flush .
	Transcript show: request; cr .
	stream receiveData: 48.
	reply := stream binary nextInBuffer: 48.
	Transcript show: reply; cr .
	len := header getLen: reply.
	Transcript show: len; cr .
      stream receiveData: len.
	reply := stream binary nextInBuffer: len.
	stream close .
	Transcript show: reply.! !


!IsectdRequest methodsFor: 'initialize' stamp: 'RK 10/3/2017 12:36'!
initialize

	super initialize.! !
