/* 
    Interface between Isectd and Progress for querying a Progress
    database without having to use ODBC
    
    isdHeader struct
    
            PUT-LONG(isdHeader,1) = 0.              len
            PUT-LONG(isdHeader,5) = 0.              sequence
            PUT-UNSIGNED-SHORT(isdHeader,9) = 0.    reply
            PUT-UNSIGNED-SHORT(isdHeader,11) = 0.   error
            PUT-UNSIGNED-SHORT(isdHeader,13) = 0.   command
            PUT-UNSIGNED-SHORT(isdHeader,15) = 0.   version
            PUT-LONG(isdHeader,17) = 0.             workerid
            PUT-UNSIGNED-SHORT(isdHeader,21) = 0.   more
            PUT-LONG(isdHeader,23) = 0.
            PUT-LONG(isdHeader,27) = 0.
            PUT-LONG(isdHeader,31) = 0.
            PUT-LONG(isdHeader,35) = 0.
            PUT-LONG(isdHeader,39) = 0.                
            PUT-LONG(isdHeader,43) = 0.
            PUT-LONG(isdHeader,47) = 0.
            PUT-LONG(isdHeader,51) = 0.
            PUT-LONG(isdHeader,55) = 0.
            PUT-LONG(isdHeader,59) = 0.
            PUT-UNSIGNED-SHORT(isdHeader,63) = 0.
*/

DEFINE VARIABLE pos2 As INTEGER.
DEFINE VARIABLE pos3 As INTEGER.
DEFINE VARIABLE bytes As INTEGER.
DEFINE VARIABLE cont As INTEGER.
DEFINE VARIABLE tsocket As INTEGER.
DEFINE VARIABLE pmsg As MEMPTR.
DEFINE VARIABLE smsg As CHARACTER.
DEFINE VARIABLE isdHeader As MEMPTR.

    SET-SIZE(pmsg)=2048.    
    SET-SIZE(isdHeader) = 64. 
    pos2 = INDEX(SESSION:PARAMETER," ").
    pos3 = INDEX(SESSION:PARAMETER," ",pos2 + 1).
    cont = 1.

    RUN isdAttach (SUBSTRING(SESSION:PARAMETER,1,pos2 - 1), SUBSTRING(SESSION:PARAMETER,pos2 + 1,pos3 - pos2),SUBSTRING(SESSION:PARAMETER,pos3 + 1), 0, OUTPUT tsocket).
    
    IF tsocket > 0 THEN DO:
            REPEAT:
                IF cont = 0 THEN LEAVE.
                RUN isdRecv(tsocket, isdHeader, OUTPUT pmsg).
                IF GET-POINTER-VALUE(pmsg) > 0 THEN DO:
                    smsg = GET-STRING(pmsg,1).
                    IF smsg = CHR(32) THEN smsg = "".
                    RUN isdSend(tsocket, smsg, -1, isdHeader, OUTPUT bytes).
                END.
                ELSE DO:
                    cont = 0.
                    RUN isdLogout (tsocket).
                END.
            END.
    END.

/* Isectd DLL external routines */
PROCEDURE isdAttach EXTERNAL "isdio_dll.dll" CDECL:
DEFINE INPUT PARAMETER hostname AS CHARACTER.
DEFINE INPUT PARAMETER service AS CHARACTER.
DEFINE INPUT PARAMETER wid AS CHARACTER.
DEFINE INPUT PARAMETER priority AS LONG.
DEFINE RETURN PARAMETER sock AS LONG.
END.

PROCEDURE isdLogout EXTERNAL "isdio_dll.dll" CDECL:
DEFINE INPUT PARAMETER sock AS LONG.
END.

PROCEDURE isdSend EXTERNAL "isdio_dll.dll" CDECL:
DEFINE INPUT PARAMETER sock AS LONG.
DEFINE INPUT PARAMETER msg AS CHARACTER.
DEFINE INPUT PARAMETER len AS LONG.
DEFINE INPUT PARAMETER isdHeader AS MEMPTR.
DEFINE RETURN PARAMETER bytes AS LONG.
END.

PROCEDURE isdRecv EXTERNAL "isdio_dll.dll" CDECL:
DEFINE INPUT PARAMETER sock AS LONG.
DEFINE INPUT PARAMETER isdHeader AS MEMPTR.
DEFINE RETURN PARAMETER msg AS MEMPTR.
END.

QUIT.
