Attribute VB_Name = "modIsect"
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (pDst As Any, pSrc As Any, ByVal ByteLen As Long)

Public Type isdHeader
    len As Long
    sequence As Long
    reply As Integer
    error As Integer
    command As Integer
    version As Integer
    workerid As Long
    more As Integer
    filler1 As Long
    filler2 As Long
    filler3 As Long
    filler4 As Long
    filler5 As Long
    filler6 As Long
    filler7 As Long
    filler8 As Long
    filler9 As Long
    filler10 As Long
    filler11 As Integer
End Type

Private Declare Function vbAttach Lib "VBisdio.dll" (ByVal hostname As Long, ByVal service As Long, ByVal wid As Long) As Integer
Private Declare Function vbLogin Lib "VBisdio.dll" (ByVal hostname As Long, ByVal service As Long, ByVal priority As Integer) As Integer
Private Declare Function vbRecv Lib "VBisdio.dll" (ByVal port As Integer, ByRef header As isdHeader) As Long
Private Declare Function vbSend Lib "VBisdio.dll" (ByVal port As Integer, ByVal message As Long, ByRef header As isdHeader) As Integer
Public Declare Sub iLogout Lib "VBisdio.dll" Alias "vbLogout" (ByVal port As Integer)

Private Function GetStringFromLP(ByRef thisPtr As Long) As String
'Use CopyMemory API function to pass a string by reference from C DLL

 Dim b As Byte
 Dim tempStr As String
 Dim bufferStr As String
 Dim Done As Boolean

 If thisPtr Then
    ' Make sure we not being given a null pointer address.
    Done = False
    Do
        ' Get the byte/character that thisPtr is pointing to.
        CopyMemory b, ByVal thisPtr, 1
        If b = 0 Then ' If you've found a null character, then you're done.
            If LenB(bufferStr) = 0 Then bufferStr = vbNullChar ' We have been sent an empty string.
            Done = True
        Else
            tempStr = Chr$(b)  ' Get the character for the byte's value.
            bufferStr = bufferStr & tempStr 'Add it to the string.
            thisPtr = thisPtr + 1  ' Increment the pointer to next byte/char.
        End If
    Loop Until Done
 End If

GetStringFromLP = bufferStr
End Function



Public Function iConnect() As Integer
'The first three arguments of the command line are defined by Isectd.
'You can pass whatever you like to your worker as long as it is from
'argument 4 onwards.
ThisCommandLine = GetCommandLine() 'Process command line containing up to 11 arguments
If UBound(ThisCommandLine) >= 3 Then
    iConnect = vbAttach(StrPtr(StrConv(ThisCommandLine(1), vbFromUnicode)), StrPtr(StrConv(ThisCommandLine(2), vbFromUnicode)), StrPtr(StrConv(ThisCommandLine(3), vbFromUnicode)))
Else
    MsgBox "This is an Isectd worker.  It can only be started by Isectd."
    End
End If
End Function

Public Function iLogin(ByVal hostname As String, ByVal service As String, ByVal priority As Integer) As Integer

    iLogin = vbLogin(StrPtr(StrConv(hostname, vbFromUnicode)), StrPtr(StrConv(service, vbFromUnicode)), priority)
End Function
Public Function iRecv(ByVal port As Integer, ByRef header As isdHeader) As String

    iRecv = GetStringFromLP(vbRecv(port, header))
End Function
Public Function iSend(ByVal port As Integer, ByVal message As String, ByRef header As isdHeader) As Integer

    iSend = vbSend(port, StrPtr(StrConv(message, vbFromUnicode)), header)
End Function
Private Function GetCommandLine(Optional MaxArgs)
    'Declare variables.
    Dim C, CmdLine, CmdLnLen, InArg, I, NumArgs
    'See if MaxArgs was provided.
    If IsMissing(MaxArgs) Then MaxArgs = 11
    'Make array of the correct size.
    ReDim ArgArray(MaxArgs)
    NumArgs = 0: InArg = False
    'Get command line arguments.
    CmdLine = command()
    CmdLnLen = Len(CmdLine)
    'Go thru command line one character
    'at a time.
    For I = 1 To CmdLnLen
        C = Mid(CmdLine, I, 1)

        'Test for space or tab.
        If (C <> " " And C <> vbTab) Then
            'Neither space nor tab.
            'Test if already in argument.
            If Not InArg Then
            'New argument begins.
            'Test for too many arguments.
                If NumArgs = MaxArgs Then Exit For
                NumArgs = NumArgs + 1
                InArg = True
            End If
            'Concatenate character to current argument.
            ArgArray(NumArgs) = ArgArray(NumArgs) & C
        Else
            'Found a space or tab.
            'Set InArg flag to False.
            InArg = False
        End If
    Next I
    'Resize array just enough to hold arguments.
    ReDim Preserve ArgArray(NumArgs)
    'Return Array in Function name.
    GetCommandLine = ArgArray()
End Function
