/*
W Robert Kellock 2002/12/11 a simple client designed to be used
with the echo worker.  It's purpose to flood the isectd server
with multiple requests for stress testing.

Usage would be:

stress -h localhost:5501 -s service -r 200 -c "The string that we want to echo"
*/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <malloc.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "../isd/isdio.h" /* W Robert Kellock 2002/12/11  hard path */
/* #include "../vb/VBisdio.h" */

#define ISDCLIENT_BUFSIZE 4096

static struct
{
int repeat;
char *command;
char *host;
char *service;
}
isdClientData;

int clientInit (int argc, char **argv)
{
int c;
int usage = 0;

extern char *optarg;
extern int optind, opterr, optopt;

#ifndef _Windows
	setbuf(stdin, NULL);
#endif

while ((c = getopt (argc, argv, "c:h:r:s:")) != -1){
    switch (c)
	{
    case 'c':
	  if (optarg){
         isdClientData.command = optarg;
         usage++;
         }
      break;
    case 'h':
	  if (optarg){
         isdClientData.host = optarg;
         usage++;
         }
      break;
    case 'r':
	  if (optarg){
         isdClientData.repeat = atoi(optarg);
         usage++;
         }
      break;
    case 's':
      if (optarg){
         isdClientData.service = optarg;
         usage++;
         }
      break;
      }
    }
return usage;
}

int
main(int argc, char **argv)
{

	SOCKET sock;
	long sequence;
	isdHeader header;
	char *msgBuffer;

if (clientInit(argc, argv) < 4)
   fprintf (stderr,
	      "%s [-c command] [-h host[:port]] [-r loop] [-s servicename]\n",
	      argv[0]);
else {
	if ((sock = isdLogin(isdClientData.host, isdClientData.service, 2)) != INVALID_SOCKET) {
		memset((char *) &header, 0, sizeof header);
		header.reply = 1;
		header.error = 0;
		header.more  = 0;
		isdLogout (sock);
		for (;;)
		{
		}
		for (sequence = 0; sequence < isdClientData.repeat; sequence++) {
				if (isdSend(sock, isdClientData.command, -1, &header) != -1) {
						if (msgBuffer = isdRecv(sock, &header))
							fwrite(msgBuffer,
								strlen(msgBuffer) < header.len ?
										strlen(msgBuffer):header.len,
								1, stdout);
						else
							break;
   				}
				else
					perror("isdSend()ing");
		}
	fflush(stdout);
	isdLogout(sock);
	}
	else
		perror("isdLogin()");

	exit(0);
}
	return 0;
}

