#include <mingw.h>  /* W Robert Kellock 2002/12/18 soft path */
#ifndef _Windows    /* W Robert Kellock 2002/08/09  added Windows switch */
#include <sys/time.h>
#include <sys/resource.h>
#else
#include <time.h>
#endif
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>

/* 09/02/93 - Mdk Increase buffer sizes of variable & value to 256 from 
   32 & 80 - was causing core dump at certain times */
/* 11/09/93 - Mdk Remove check for a space in scanf for !PUTENV value;
   was causing problems using SQR_LICENSE via jcpconfig file */

int 
rmtchild(buffer)
char *buffer;
{
	char *argvs[200];
	int err, i = 0, p = 0, j;
#ifndef _Windows /* W Robert Kellock 2002/08/15 */
	err = fork();
#endif
	if (err == 0) { /* we are the child */
		int size, niceval = 4, keepstdio = 0, dopause = 0;
		#ifndef _Windows /* W Robert Kellock 2003/02/17 */
		        extern char **environ;
		#endif
		char variable[256];
		char command[64];
		char value[256];
		char *cp, *tp;
		int index;

		for (tp = strtok(buffer, "\n"); tp && *tp == '!'; tp = strtok((char *) NULL, "\n")) {
			sscanf(tp, "%s %[^ =]%*[ =]%n", command, variable, &index);
			strupr(command);

#if 1 == 2
			if (strcmp(command, "!NICE") == 0) {
				sscanf(tp, "%*s %d", &niceval);
				setpriority(PRIO_PROCESS, 0, niceval);
			}

			else
#endif
			if (strcmp(command, "!PAUSE") == 0) {
				dopause = 1;
			}

			else if (strcmp(command, "!PUTENV") == 0) {
				sscanf(&tp[index], "%[^\n]", value);
				sprintf(command, "%s=%s", variable, value);

				if (putenv(strdup(command)))
					isdLog("Error: putenv(\"%s\")", command);
			}

			else if (strcmp(command, "!STDIO") == 0) {
				keepstdio = 1;
			}

			else;
		}

		if (tp == NULL)
			tp = buffer;

		size = strlen(tp);

#ifndef _Windows		
        if (dopause)
			pause();
#endif			

		while (p < size) {
			if (tp[p] != '"') {
				argvs[i++] = &tp[p];

				for (; p < size && tp[p] != ' ' && tp[p] != '"'; p++);
				if (tp[p] == '"') {
					for (; p < size && tp[p] != '"'; p++);
					tp[p++] = 0;
					p++;
				}
				else
					tp[p++] = 0;
			}
			else {
				p++;
				argvs[i++] = &tp[p];
				for (; p < size && tp[p] != '"'; p++);
				tp[p++] = 0;
				p++;
			}

		}
		argvs[i] = (char *) 0;
/*
		if (!keepstdio) {
			close(0);
			close(1);
			close(2);
		}
*/
		close(3);
		close(4);

		err = execvp(argvs[0], argvs);
		isdError("execvp('%s', ..) : %s\n", argvs[0]);
		exit(errno);
	}
	else if (err > 0)
		isdLog("fork()=%d\n", err);

	else
		isdError("fork()");

	return err;
}
