#include "isdio.h"
#include <memory.h>

void isdOutBadge(isdBadgeStr *badgeStr, isdBadge *badge)
{
	/* 
		Convert outgoing native isdBadge struct to string array
	*/
	itoa(badge->hostpid, badgeStr->hostpid, 10);
	itoa(badge->priority, badgeStr->priority, 10);
	itoa(badge->id, badgeStr->id, 10);
	itoa(badge->blockable, badgeStr->blockable, 10);
	strcpy(badgeStr->service, badge->service);
}


Xport SOCKET isdAttach(const char *hostname, const char *service, char *wid, int priority)
{
	int err = INVALID_SOCKET;
	SOCKET sock;
	isdBadge badge;
	isdBadgeStr badgeStr;
	isdHeader header;

#ifdef _Windows
	WSADATA wsadata;
	if(WSAStartup((WORD) MAKEWORD(2, 0), &wsadata) != 0)
       isdSocketError(WSAGetLastError());
#endif

	if (hostname == (char *) 0)
		hostname = ISDHOSTNAME;
		
	isdLog("myHost = %s, service = %s\n",hostname,service);

	if ((sock = isdConnectTo(hostname, wid == NULL ? ISDHOSTNAME:service)) != INVALID_SOCKET) {
		badge.id = wid == NULL ? 0 : atol(wid);
		badge.priority = priority;
		badge.hostpid = getpid();
		badge.blockable = 0;
		strcpy(badge.service, service);
		isdOutBadge(&badgeStr, &badge);
		memset((char *) &header, 0, sizeof header);
		if (isdSend(sock, (char *) &badgeStr, sizeof badgeStr, &header) != -1)
			err = 0;
	}

	if (err != 0)
		isdLogout(sock);

	return err == 0 ? sock : err;
}
