#include "isdio.h"
#include <errno.h>
#include <time.h>
#include <string.h>

static FILE *isdLogFile;

static char * /* W Robert Kellock 2002/08/16 Xport */
strTime(void)
{
	time_t tval;
	char *cp, *nl;

	tval = time((time_t *) 0);
	cp = ctime(&tval);
	if (nl = strchr(cp, '\n'))
		*nl = 0;

	return cp;
}

Xport void isdLogInit(int argc, char **argv)
{
	int i;
	char isdLogFileName[1024];

	sprintf(isdLogFileName, "/isect/logs/%s.log", argv[1]);

	isdLogFile = fopen(isdLogFileName, "a");
	if (isdLogFile == NULL)
		isdLogFile = stderr;

	isdLog("\nSTARTING\n");
	for (i = 0; i < argc; i++)
		isdLog("%s ", argv[i]);
}


Xport void isdLog(char *fmt,...)
{
	va_list args;

	va_start(args, fmt);
				     /* 
					W Robert Kellock 2014/07/11 changing from stderr to stdout
					was a bad idea, particularly for CGI development which uses
					stdout to communicate with the web server.  Changed it back 
					to stderr 
				     */
	if (isdLogFile == NULL)
		isdLogFile = stderr; /* W Robert Kellock 2003/02/17 changed from stderr to stdout to enable redirection on Windows95/98/ME */

	fprintf(isdLogFile, "%s ", strTime());
	vfprintf(isdLogFile, fmt, args);
	fflush(isdLogFile);

	va_end(args);
}

Xport void isdError(char *fmt,...)
{
	va_list args;

	va_start(args, fmt);

	if (isdLogFile == NULL)
		isdLogFile = stderr;

	fprintf(isdLogFile, "SystemError : %d, %s\n\t\t", errno, strerror(errno));
	vfprintf(isdLogFile, fmt, args);
	fflush(isdLogFile);

	va_end(args);
}
