#include <stdlib.h>
#include <string.h>
#include <errno.h>

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef HAVE_WRITEV
#include <sys/uio.h>
#endif

#include "isdio.h"

void isdOutHeader(isdHeaderStr *headerStr, isdHeader *header)
{
	/* 
		Convert outgoing native isdHeader struct to string array
	*/
	itoa(header->len, headerStr->len, 10);
	itoa(header->reply, headerStr->reply, 10);
	itoa(header->more, headerStr->more, 10);
	itoa(header->sequence, headerStr->sequence, 10);
	itoa(header->error, headerStr->error, 10);
	itoa(header->command, headerStr->command, 10);
	itoa(header->version, headerStr->version, 10);
	itoa(header->workerid, headerStr->workerid, 10);
}

Xport int isdSend(SOCKET socket, char *message, int len, isdHeader * header)
{
	int bytes;
	isdHeader myheader;
	isdHeaderStr headerStr;
#ifdef HAVE_WRITEV
	struct iovec sendVec[2];
#endif

	/* W Robert Kellock 2002/08/22 added len assignment to strlen */
    	header->len = len == -1 ? len = strlen(message) + 1 : len;
	myheader = *header;
	isdOutHeader(&headerStr, &myheader);

#ifdef HAVE_WRITEV
	sendVec[0].iov_base = (void *) &myheader;
	sendVec[0].iov_len = sizeof myheader;

	sendVec[1].iov_base = (void *) message;
	sendVec[1].iov_len = header->len;

	do {
		bytes = writev(socket, sendVec, 2);
	} while (bytes == -1 && errno == EINTR);

	if (bytes > 0)
		bytes -= sizeof myheader;

#else

	if ((bytes = send(socket, (char *) &headerStr, sizeof headerStr, 0)) == sizeof headerStr)
		bytes = send(socket, message, len, 0);

#endif

	return bytes;
}
