/*
1/3/2001	tgagne@ix.netcom.com	if (client->header.reply)...
6/6/2000	make sure the request to isdCommand is null terminated.
*/

#include <stdlib.h>
#include "isectd.h"

void isdCheckReady(fd_set readfds)
{
	Node *node;
	isdClient *client;
	char *requestNullTerminated, *msgBuffer, *cp;
	
	for (node = QNULL; (node = QueueSearch(&isdData.PriList, QEQ, offsetof(isdClient, ready), 0, node)) != QNULL;) {
		client = (isdClient *) node;
		if (client->socket == INVALID_SOCKET)
			node = (Node *) isdClientEOF(client);
		else {
			if (FD_ISSET(client->socket, &readfds)) {
				if (!client->blocked){
				      msgBuffer = isdRecv(client->socket, &client->header);
				      if (msgBuffer) {
                          isdLogEvent("checkready len=%d, seq=%d, more=%d",
								client->header.len,
								client->header.sequence,
								client->header.more);
					      client->fromCount++;
					      /* 
                             Robert Kellock 22/11/2004
                             Below is a memory leak from the malloc
                             call with no free call to go with it.
                             See isdToWorker.c for the fix.
                          */
                          client->msgBuffer = malloc(client->header.len);
					      memcpy(client->msgBuffer, msgBuffer, client->header.len);
					      if (client->service_id == isdData.opid) {
						     requestNullTerminated = malloc(client->header.len+1);
						     memcpy(requestNullTerminated, client->msgBuffer, client->header.len);
						     requestNullTerminated[client->header.len]=0;
						     cp = isdCommands(requestNullTerminated);
						     free(requestNullTerminated);
						     client->header.len = -1;
						     isdClientSend(client, cp, &client->header);
					      }
					      else {
						       client->ready = 1;
						       client->blocked = 1;
						       /* Robert Kellock 24/07/2002 moved FD_CLR from below if statement
						       to above it and removed comments */
                               FD_CLR(client->socket, &isdData.allfds);
                               if (client->worker){
      						      isdLogEvent("checkready client 0x%x allocated to pre-assigned worker 0x%x",
									client, client->worker);
							      isdToWorker(client->worker);
			                   }	
                          }
				      }	       
				      else
					      node = (Node *) isdClientEOF(client);
			    }		
	            else {  
	              /*  A client can be blocked two ways:
                  
                      1.  It is blocked by the administrator.
                      2.  It is blocked by Isectd until it is 
                          freed by a worker reply.  This is 
                          necessary for when a client application 
                          has specified it does not want to receive
                          a reply to a worker request, but then
                          immediately follows this up with another
                          request.
                  */
                  isdLogEvent("checkready client 0x%x blocked, client->id %d",	client, client->id);
                  if (!FD_ISSET(client->socket, &isdData.allfds))
			         FD_SET(client->socket, &isdData.allfds);
                }   
            }
		}
	}
}
