#include "isectd.h"
#ifdef _Windows
#include <dos.h>
#endif

int 
isdStartWorkers(void)
{
	int err = 0;
	Node *node;
	isdWorker *worker;

	for (node = isdData.LazyWorkers.head; node != QNULL; node = node->next) {
		worker = (isdWorker *) node;
		isdLog("starting worker %d for service %s\n",worker->id,worker->name);
		err = isdStartWorker(worker);
	}
	return err;
}

int
isdStartWorker(isdWorker * worker)
{
/* 
	2018-12-21	W. Robert Kellock
	Currently command line arguments are arranged as follows:

	worker->path, isdData.host, isdData.port, worker->id, worker->name, worker->args

	A worker calls back to Isectd with isdData.host, isdData.port, worker->id, worker->name is ignored and worker->args
	is utilised by the worker for it's own purposes. The problem is that a scripting worker needs the command line 
	argument order to be:

	worker->path, worker->args, isdData.host, isdData.port, worker->id

	so that it can start using it's own arguments without having to resort to using a scriptworker proxy. worker->name
	has been removed as it is not used.
*/
	int err = 0;
	char command[256];

	if (worker->stopped == 0 && worker->up_not_log_in == 0) {
		worker->restarts++;
		//sprintf(command, "%s %s %d %d -s%s %s", worker->path, isdData.host, isdData.port, worker->id, worker->name, worker->args);
		sprintf(command, "%s %s %s %d %d", worker->path, worker->args, isdData.host, isdData.port, worker->id);
		if (err = isdexec(worker->host, command)) {
			isdLog("rmtexec(\"%s\", \"%s\") = %d : ", worker->host, command, err);
			isdLog(isdxstrerror(err));
			Sleep(1);
		}
		else
			worker->up_not_log_in = 1;
	}

	return err;
}
