#include "isectd.h"
#include "../lib/tvfuncs.h"  /* W Robert Kellock 2002/08/09  hard path */
/* 
   W Robert Kellock 2002/11/22 tidied formatting code
*/

char *
isdStatWorkerQueue(char *cp, Queue * queue)
{
	ISDTIMETYPE now, tp;
	isdWorker *worker;

	cp += ADDBYTES(sprintf(cp, "%12s  %6s  %6s  %12s  %10s  %8s  %10s  %10s  %8s  %6s  %5s\n",
						   "service", "worker", "avail?", "hostname", "host pid", "xactions", "avg. resp.", "last resp.", "restarts", "client", "fd"));

	for (worker = (isdWorker *) queue->head; worker != (isdWorker *) QNULL; worker = (isdWorker *) worker->node.next) {
		now = worker->LastTime;
		if (queue == &isdData.BusyWorkers && worker->header.command == 0) {
			GetTime(&tp);
			now = tvMinus(&tp, &worker->LastTime);
		}

		cp += ADDBYTES(sprintf(cp, "%12s  %6d  %6s  %12s  %10d  %8d  %6d.%03.3d  %6d.%03.3d  %8d  %6d  %5d\n",
							   worker->name,
							   worker->id,
							   worker->stopped ? "no" : "yes",
#ifdef inet_ntoa
							   inet_ntoa(worker->sockaddr.sin_addr.s_addr),
#else
							   worker->loghost,
#endif
							   worker->hostpid,
							   worker->Transactions,
		  worker->AverageTime.tv_sec, worker->AverageTime.tv_usec / 1000,
							   now.tv_sec, now.tv_usec / 1000,
							   worker->restarts,
							   worker->client ? worker->client->id : 0,
							   worker->socket));
	}
	return cp;
}
