/*
Copyright, 1997, Isect
*/
#include <stdio.h>
#include <errno.h>
#include "../isd/isdio.h"  /* W Robert Kellock 2002/08/09 hard path */

int main(int argc, char **argv)
{
	int bytes;
	SOCKET sock;
	isdHeader header;
	char *msgBuffer;

	isdLogInit(argc, argv);

	if (argc >= ISDARGMAX) {
		if ((sock = isdConnect(argv)) != -1) {
			for (;;) {
				if (msgBuffer = isdRecv(sock, &header)) {
					isdLog("Worker %s received message '%s'\n", argv[ISDARGWID], msgBuffer);
					bytes = isdSend(sock, msgBuffer, header.len, &header);
					if (bytes < 0)
						isdError("%s: isdSend() reply\n", argv[ISDARGWID], strerror(errno));
				}
				else
					break;
			}
			isdLog("Worker %s exiting\n", argv[ISDARGWID], strerror(errno));
			isdLogout(sock);
		}
		else
			isdError("isdConnect(): %s\n", strerror(errno));
	}
	else
		fprintf(stderr, "Incorrect number of arguments\n");
	return 0;
}
