/*
	Copyright, 1997, Isect

	This Isectd worker calls the operating system with a command.
*/
#include <stdio.h>
#include <errno.h>
#include "../isd/isdio.h"  /* W Robert Kellock 2002/08/09 hard path */

int main(int argc, char **argv)
{
	int bytes;
	SOCKET sock;
	isdHeader header;
	char *msgBuffer;

	isdLogInit(argc, argv);

	if (argc >= ISDARGMAX) {
		//if ((sock = isdConnect(argv)) != -1) {
		if ((sock = isdAttach (argv[argc-3], argv[argc-2], argv[argc-1], 0)) != -1) {
			for (;;) {
				if (msgBuffer = isdRecv(sock, &header)) {
					isdLog("Worker %s received message '%s'\n", argv[ISDARGWID], msgBuffer);
					if(system(msgBuffer))
						msgBuffer = "Fail\n";
					else msgBuffer = "Pass\n";
					bytes = isdSend(sock, msgBuffer, -1, &header);
					if (bytes < 0)
						isdError("%s: isdSend() reply\n", argv[ISDARGWID], strerror(errno));
				}
				else
					break;
			}
			isdLog("Worker %s exiting\n", argv[ISDARGWID], strerror(errno));
			isdLogout(sock);
		}
		else
			isdError("isdConnect(): %s\n", strerror(errno));
	}
	else
		fprintf(stderr, "Incorrect number of arguments\n");
	return 0;
}
